extern char *malloc(), *realloc();

# line 6 "gram.y"
#include <stdio.h>
#include <math.h>
#include "art.h"
#include "macro.h"

extern object	*objectinit(),
		*compinit(),
		*csginit(),
		*getcsgobj(),
		*getcsgexp(),
		*treeinit(),
		*gridinit();

extern symbol	*lookup();

extern light	*lightinit();
extern texture	*textureinit();
extern wlist	*waveinit();
extern cmap	*mapinit();

extern attr	*astackp;
extern mats	*mstackp;

extern object	**oblistsp;
extern object	*subobjs;
extern light	*lights;

extern vector	org, up;

extern matrix	trans;
extern float	focallength;

extern char	*title;
extern int	maxhitlevel, raysperpix, pixelgrid;
extern long	filetype;

extern colour	backcol;

extern float	fogfactor, rfactor;
extern colour	hazecolour;

extern float	huge_dist;

extern float	sourceradius;
extern float	falloff;
extern float	ri;

extern float	screenx, screeny;
extern int	maxtreedepth;
extern int	perspective;

extern int	frameno;
extern int	gridsize[];
extern int	usegrid;

extern int	adaptive;
extern real	aathreshold;

extern float		eval_fexpr();
extern int		eval_iexpr();
extern expression	*get_expr(), *get_varexpr();

#ifndef M_PI
#define M_PI	3.14159265358979323846
#endif

static int	objdefined = FALSE;
static int	fieldtype;

extern objst	*ostackp;


# line 79 "gram.y"
typedef union {
	object		*y_obj;
	vector		*y_pnt;
	details		*y_det;
	char		*y_str;
	eqn		*y_eqn;
	term		*y_trm;
	expression	*y_exp;
	symbol		*y_sym;
	csgnode		*y_csg;
	float		y_flt;
	int		y_int;
} YYSTYPE;
# define CSG 257
# define COMPOSITE 258
# define OBJECT_TYPE 259
# define FLOAT 260
# define INTEGER 261
# define FILETYPE 262
# define OPTION 263
# define NAME 264
# define LBRACE 265
# define RBRACE 266
# define LP 267
# define RP 268
# define RADIUS 269
# define RADII 270
# define COLOUR 271
# define CENTER 272
# define VERTEX 273
# define COMMA 274
# define PCENT 275
# define MATERIAL 276
# define REFI 277
# define MINUS 278
# define AMBIENT 279
# define INTENSITY 280
# define LOCATION 281
# define DOLS 282
# define EQUATION 283
# define OFFFILE 284
# define BASE 285
# define TOP 286
# define CONST 287
# define COEFFS 288
# define SCALE 289
# define ROTATE 290
# define TRANSLATE 291
# define TITLE 292
# define REFLECTANCE 293
# define DOT 294
# define ON 295
# define OFF 296
# define LOOKAT 297
# define FIELDOFVIEW 298
# define TRANSPARENCY 299
# define RAYSPERPIXEL 300
# define BACKGROUND 301
# define SIZE 302
# define MAXHITLEVEL 303
# define OUTPUT 304
# define ORDER 305
# define ABSORPTION 306
# define VREF1 307
# define VREF2 308
# define NUMRAYS 309
# define OBJECT 310
# define TEXTURE 311
# define DIRECTION 312
# define ANGLE 313
# define UP 314
# define TWENTYFIVEBIT 315
# define RANGE 316
# define MAP 317
# define BLENDCOLOR 318
# define SCALEFACTORS 319
# define VORTFILE 320
# define HAZECOLOUR 321
# define FOGFACTOR 322
# define RFACTOR 323
# define FALLOFF 324
# define QUOTE 325
# define REPEAT 326
# define SHADOWS 327
# define COLOURFILE 328
# define VNORMALFILE 329
# define SCALEFACTOR 330
# define SOURCE 331
# define AMPLITUDE 332
# define WAVELENGTH 333
# define PHASE 334
# define TURBULENCE 335
# define SQUEEZE 336
# define DAMPING 337
# define SOURCERADIUS 338
# define NORMAL 339
# define COMPLEXVERTEX 340
# define SCREENSIZE 341
# define MAXTREEDEPTH 342
# define BLEND 343
# define COLOURMAP 344
# define MAPVALUES 345
# define PIXELGRID 346
# define RI 347
# define COLOURBLEND 348
# define NORMALFILE 349
# define BEAMDISTRIBUTION 350
# define INSIDEANGLE 351
# define PROJECTION 352
# define PERSPECTIVE 353
# define ORTHOGRAPHIC 354
# define STRIP 355
# define VCOLOURFILE 356
# define TRANSFORM 357
# define MINDIST 358
# define CLIPVOLUME 359
# define HEIGHTFIELD 360
# define FRAMENO 361
# define BLOCKSIZE 362
# define GAPCOLOUR 363
# define GAPSIZE 364
# define COLOURFIELD 365
# define ALPHA 366
# define GEOMX 367
# define GEOMY 368
# define GEOMZ 369
# define ANTIALIASING 370
# define ADAPTIVE 371
# define BRUTE 372
# define THRESHOLD 373
# define METABALL 374
# define BASIS 375
# define MAXSUBLEVEL 376
# define SUBDIVISION 377
# define GRID 378
# define KDTREE 379
# define PLUS 380
# define MULT 381
# define DIV 382
# define POWER 383
# define UMINUS 384
# define EQUALS 385
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256
int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 189
# define YYLAST 2199
int yyact[]={

   220,   277,   368,   326,   406,   293,   175,   385,    84,    91,
    92,    93,    94,    95,    96,    97,     1,   212,   213,   252,
   119,   211,   106,   107,   210,   109,   551,   176,   177,   553,
   175,    30,   549,   103,   122,   291,   175,   120,   121,   193,
   128,   175,   130,   131,   132,   136,   101,   102,   139,   140,
   141,   142,   547,   544,    98,   545,   175,   301,   436,   175,
   151,   110,   111,   161,   162,   175,   152,   153,    99,   100,
   386,   137,   165,   166,   167,   168,   169,   541,   491,   172,
   412,   175,   540,   205,   365,   537,   175,   455,   413,   175,
   536,   179,   170,   533,   175,   271,   532,   175,   164,   129,
   175,   523,   127,   529,   182,   183,   184,   175,   174,   176,
   177,   175,     5,   125,   124,   123,   528,   383,   488,   192,
   175,   195,   105,   104,   198,   199,   200,   201,   202,   386,
   203,   446,   174,   176,   177,   357,   206,   290,   174,   176,
   177,   118,   288,   174,   176,   177,   525,   136,   117,   116,
   175,   115,   524,   116,   515,   114,   175,   117,   174,   176,
   177,   174,   176,   177,   175,   245,   519,   174,   176,   177,
   175,   246,   384,   385,   247,   248,   249,   250,   251,   112,
     3,   253,   254,   174,   176,   177,   257,   313,   174,   176,
   177,   174,   176,   177,   273,   303,   174,   176,   177,   174,
   176,   177,   174,   176,   177,   284,   136,   276,   287,   174,
   176,   177,   119,   174,   176,   177,   295,   136,   259,   298,
   264,   518,   174,   176,   177,   175,   113,   492,   115,   114,
   274,   384,   385,   304,   305,   306,   307,   308,   309,   175,
   311,   312,   517,   314,   315,   316,   175,   214,   229,   113,
   112,   485,   174,   176,   177,   191,   321,   322,   174,   176,
   177,   175,   138,   189,   187,   173,   174,   176,   177,   146,
   126,   512,   174,   176,   177,   175,   338,   310,   302,   344,
   345,   346,   347,   348,   349,   300,   178,   351,   171,   353,
   388,   337,   163,   339,   259,   389,   150,   149,   331,   148,
   361,   509,   264,   328,   369,   175,   212,   213,   147,   341,
   211,   508,   145,   210,   144,   175,   143,    83,   376,   377,
   378,   379,   435,   108,   382,   134,   259,   174,   176,   177,
   506,   188,   386,   366,   175,   387,   272,   391,   160,   390,
   159,   174,   176,   177,   395,   158,   157,   133,   174,   176,
   177,   402,   505,   404,   156,   155,   175,   154,   407,   186,
   408,   409,   501,   174,   176,   177,   175,   328,   335,   266,
   498,   415,   416,   417,   175,   425,   426,   174,   176,   177,
   196,   430,   431,   496,   329,   363,   467,   175,   432,   433,
   434,   194,    85,    86,   437,   190,    89,     4,   439,   440,
   441,   442,   443,   484,   444,     2,   367,   174,   176,   177,
    90,   449,   419,   175,   369,   452,   451,   174,   176,   177,
   411,   373,   456,   457,   458,   459,   216,   209,   462,   463,
   464,   474,    79,   289,   384,   385,   174,   176,   177,     0,
   468,   175,     0,   366,     0,     0,   475,   476,   329,   477,
     0,   266,     0,     0,   479,   480,   481,    88,   174,   176,
   177,   482,   483,     0,     0,     0,     0,   487,   174,   176,
   177,     0,   490,     0,     0,     0,   174,   176,   177,   493,
     0,     0,     0,     0,   494,     0,     0,   495,   175,   174,
   176,   177,   499,    87,   217,   500,     0,   502,     0,   504,
   341,     0,   507,     0,     0,   497,   510,   511,   486,   513,
   514,     0,   175,   516,   473,   174,   176,   177,   520,   521,
   522,   270,     0,   478,   175,   526,   527,   175,     0,   530,
   531,   285,     0,   534,   535,     0,     0,   538,   539,     0,
     0,   542,   543,   174,   176,   177,   546,   262,   548,     0,
   550,     0,   552,    28,    27,    26,     0,     0,     0,    68,
    29,     0,   503,     0,   297,    42,    43,    61,    38,    44,
     0,   208,    59,     0,   294,    62,     0,    70,     0,    45,
    53,    50,    49,    48,    47,    36,    34,    35,     6,    63,
   174,   176,   177,    20,     7,    64,    10,    21,     0,    22,
    23,    41,    67,     0,     0,    71,     0,    69,    76,    75,
    19,    16,     0,     0,   174,   176,   177,    11,    12,    13,
    24,   447,    33,    60,    56,    57,   174,   176,   177,   174,
   176,   177,     0,   175,    14,     0,     0,     8,     9,   472,
     0,     0,    15,    66,   292,    58,    73,    72,    25,   175,
     0,    54,    55,    37,    74,    46,    51,     0,     0,     0,
     0,    52,    65,    80,    81,    82,    17,    18,     0,    39,
    40,    77,    78,    32,    28,    27,    26,     0,     0,     0,
    68,    29,     0,   394,     0,     0,    42,    43,    61,    38,
    44,     0,     0,    59,     0,     0,    62,     0,    70,     0,
    45,    53,    50,    49,    48,    47,    36,    34,    35,     6,
    63,     0,     0,     0,    20,     7,    64,    10,    21,     0,
    22,    23,    41,    67,   354,   355,    71,     0,    69,    76,
    75,    19,    16,     0,     0,   174,   176,   177,    11,    12,
    13,    24,     0,    33,    60,    56,    57,     0,     0,     0,
   471,   174,   176,   177,   175,    14,     0,     0,     8,     9,
   470,     0,     0,    15,    66,     0,    58,    73,    72,    25,
   175,     0,    54,    55,    37,    74,    46,    51,     0,     0,
     0,     0,    52,    65,    80,    81,    82,    17,    18,     0,
    39,    40,    77,    78,    32,    28,    27,    26,     0,     0,
     0,    68,    29,     0,   392,     0,     0,    42,    43,    61,
    38,    44,     0,     0,    59,     0,     0,    62,     0,    70,
     0,    45,    53,    50,    49,    48,    47,    36,    34,    35,
     6,    63,     0,     0,     0,    20,     7,    64,    10,    21,
     0,    22,    23,    41,    67,     0,     0,    71,     0,    69,
    76,    75,    19,    16,     0,     0,   174,   176,   177,    11,
    12,    13,    24,     0,    33,    60,    56,    57,     0,     0,
     0,   466,   174,   176,   177,   175,    14,     0,     0,     8,
     9,   469,     0,     0,    15,    66,     0,    58,    73,    72,
    25,   175,     0,    54,    55,    37,    74,    46,    51,     0,
     0,     0,     0,    52,    65,    80,    81,    82,    17,    18,
     0,    39,    40,    77,    78,    32,    28,    27,    26,     0,
     0,     0,    68,    29,     0,     0,     0,     0,    42,    43,
    61,    38,    44,     0,     0,    59,     0,     0,    62,     0,
    70,     0,    45,    53,    50,    49,    48,    47,    36,    34,
    35,     6,    63,     0,     0,     0,    20,     7,    64,    10,
    21,     0,    22,    23,    41,    67,     0,     0,    71,     0,
    69,    76,    75,    19,    16,     0,     0,   174,   176,   177,
    11,    12,    13,    24,     0,    33,    60,    56,    57,   465,
     0,     0,   461,   174,   176,   177,   175,    14,   460,   175,
     8,     9,   175,     0,     0,    15,    66,   438,    58,    73,
    72,    25,     0,     0,    54,    55,    37,    74,    46,    51,
   175,     0,     0,     0,    52,    65,    80,    81,    82,    17,
    18,     0,    39,    40,    77,    78,    32,   333,   334,   330,
     0,     0,     0,    68,   332,     0,     0,   331,     0,    42,
    43,    61,    38,    44,     0,     0,    59,     0,     0,    62,
     0,    70,     0,    45,    53,    50,    49,    48,    47,    36,
    34,    35,     0,    63,     0,     0,     0,    85,    86,    64,
     0,    89,     0,   296,   135,    41,    67,     0,     0,    71,
   454,    69,    76,    75,   175,    90,     0,     0,   174,   176,
   177,   174,   176,   177,   174,   176,   177,    60,    56,    57,
   453,     0,     0,   448,   175,     0,   445,   175,     0,     0,
   175,     0,   174,   176,   177,     0,     0,    66,   429,    58,
    73,    72,   175,     0,     0,    54,    55,    37,    74,    46,
    51,     0,    88,     0,     0,    52,    65,    80,    81,    82,
   396,     0,     0,    39,    40,    77,    78,   269,   268,   267,
   175,     0,     0,    68,   261,     0,   325,     0,     0,    42,
    43,    61,    38,    44,     0,     0,    59,     0,    87,    62,
     0,    70,     0,    45,    53,    50,    49,    48,    47,    36,
    34,    35,     0,    63,     0,     0,   174,   176,   177,    64,
     0,     0,     0,     0,     0,    41,    67,     0,     0,    71,
   428,    69,    76,    75,   175,     0,   174,   176,   177,   174,
   176,   177,   174,   176,   177,     0,     0,    60,    56,    57,
     0,     0,     0,   427,   174,   176,   177,   175,   414,   197,
     0,     0,   175,     0,   410,     0,     0,    66,   175,    58,
    73,    72,   175,     0,     0,    54,    55,    37,    74,    46,
    51,     0,   174,   176,   177,    52,    65,    80,    81,    82,
     0,     0,     0,    39,    40,    77,    78,   269,   268,   267,
     0,     0,     0,    68,   261,     0,   263,     0,     0,    42,
    43,    61,    38,    44,     0,     0,    59,     0,     0,    62,
     0,    70,     0,    45,    53,    50,    49,    48,    47,    36,
    34,    35,     0,    63,     0,     0,   174,   176,   177,    64,
     0,     0,     0,   403,     0,    41,    67,   175,     0,    71,
     0,    69,    76,    75,   175,     0,     0,     0,   405,   174,
   176,   177,     0,     0,   174,   176,   177,    60,    56,    57,
   174,   176,   177,     0,   174,   176,   177,     0,   401,     0,
     0,   400,   175,     0,   399,   175,     0,    66,   175,    58,
    73,    72,     0,     0,     0,    54,    55,    37,    74,    46,
    51,     0,     0,     0,   418,    52,    65,    80,    81,    82,
   420,     0,     0,    39,    40,    77,    78,    68,   261,     0,
   358,     0,     0,    42,    43,    61,    38,    44,     0,     0,
    59,     0,     0,    62,     0,    70,     0,    45,    53,    50,
    49,    48,    47,    36,    34,    35,     0,    63,     0,   174,
   176,   177,     0,    64,     0,     0,   174,   176,   177,    41,
    67,     0,     0,    71,   398,    69,    76,    75,   175,     0,
   422,   421,   423,     0,     0,   424,   397,     0,     0,     0,
   175,    60,    56,    57,   174,   176,   177,   174,   176,   177,
   174,   176,   177,   393,     0,     0,   381,   175,     0,     0,
   175,    66,   380,    58,    73,    72,   175,     0,     0,    54,
    55,    37,    74,    46,    51,     0,     0,     0,     0,    52,
    65,    80,    81,    82,     0,     0,     0,    39,    40,    77,
    78,    68,   261,     0,   324,     0,     0,    42,    43,    61,
    38,    44,     0,     0,    59,     0,     0,    62,     0,    70,
     0,    45,    53,    50,    49,    48,    47,    36,    34,    35,
     0,    63,     0,     0,     0,     0,     0,    64,     0,     0,
   174,   176,   177,    41,    67,     0,     0,    71,     0,    69,
    76,    75,   174,   176,   177,     0,     0,     0,     0,     0,
   375,     0,     0,     0,   175,    60,    56,    57,     0,   174,
   176,   177,   174,   176,   177,     0,     0,   374,   174,   176,
   177,   175,   372,     0,     0,    66,   175,    58,    73,    72,
     0,     0,     0,    54,    55,    37,    74,    46,    51,     0,
     0,     0,     0,    52,    65,    80,    81,    82,     0,     0,
     0,    39,    40,    77,    78,    68,   261,     0,   258,     0,
     0,    42,    43,    61,    38,    44,     0,     0,    59,     0,
   371,    62,     0,    70,   175,    45,    53,    50,    49,    48,
    47,    36,    34,    35,   370,    63,     0,     0,   175,   360,
     0,    64,   359,   175,     0,   352,   175,    41,    67,   175,
     0,    71,     0,    69,    76,    75,   174,   176,   177,   212,
   213,   350,     0,   211,   336,   175,   210,   356,   175,    60,
    56,    57,     0,   174,   176,   177,     0,   291,   174,   176,
   177,   323,     0,     0,   320,   175,     0,     0,   175,    66,
   319,    58,    73,    72,   175,   219,     0,    54,    55,    37,
    74,    46,    51,     0,     0,     0,     0,    52,    65,    80,
    81,    82,     0,     0,     0,    39,    40,    77,    78,   318,
     0,     0,     0,   175,     0,   317,   174,   176,   177,   175,
   299,     0,     0,   286,   175,     0,     0,   175,     0,   283,
   174,   176,   177,   175,     0,   174,   176,   177,   174,   176,
   177,   174,   176,   177,   282,     0,     0,   281,   175,     0,
   280,   175,     0,     0,   175,     0,     0,   174,   176,   177,
   174,   176,   177,   279,     0,     0,   278,   175,     0,   290,
   175,   275,     0,     0,     0,   175,     0,   174,   176,   177,
   174,   176,   177,     0,     0,   256,   174,   176,   177,   175,
   255,     0,     0,   218,   175,     0,   215,   175,     0,   207,
   175,     0,   204,   175,     0,   185,   175,     0,   181,   175,
     0,     0,   175,     0,   180,   174,   176,   177,   175,     0,
     0,   174,   176,   177,     0,     0,   174,   176,   177,   174,
   176,   177,    31,     0,     0,   174,   176,   177,     0,     0,
     0,   222,   223,   224,   225,   226,   227,     0,     0,     0,
   174,   176,   177,   174,   176,   177,   174,   176,   177,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   174,
   176,   177,   174,   176,   177,     0,     0,   174,   176,   177,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   174,   176,   177,   450,     0,   174,   176,   177,   174,
   176,   177,   174,   176,   177,   174,   176,   177,   174,   176,
   177,   174,   176,   177,   174,   176,   177,    36,    34,    35,
   174,   176,   177,     0,     0,     0,     0,     0,     0,   364,
   235,     0,    85,    86,     0,     0,    89,    85,    86,   135,
     0,    89,     0,     0,   233,   230,   234,   236,   238,     0,
    90,     0,    36,    34,    35,    90,     0,     0,   237,   241,
     0,     0,     0,   239,   240,   235,     0,     0,     0,     0,
     0,   232,   231,     0,     0,     0,     0,   362,     0,   233,
   230,   234,   236,   238,     0,    37,     0,     0,   221,     0,
   244,   243,   242,   237,   241,     0,     0,    88,   239,   240,
     0,     0,    88,     0,   342,     0,   232,   231,     0,     0,
     0,   489,   228,     0,   235,     0,     0,     0,     0,   260,
    37,   265,     0,     0,     0,   244,   243,   242,   233,   230,
   234,   236,   238,    87,    36,    34,    35,     0,    87,     0,
     0,     0,   237,   241,     0,     0,     0,   239,   240,   235,
     0,     0,     0,     0,   342,   232,   231,     0,     0,     0,
     0,   340,     0,   233,   230,   234,   236,   238,     0,     0,
     0,   343,     0,     0,   244,   243,   242,   237,   241,     0,
     0,     0,   239,   240,    36,    34,    35,     0,     0,     0,
   232,   231,     0,     0,     0,   260,     0,     0,     0,     0,
     0,     0,    37,   265,   327,     0,     0,     0,     0,   244,
   243,   242,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   343,     0,     0,     0,     0,     0,   260,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,    37,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   327 };
int yypact[]={

 -1000,   659, -1000, -1000, -1000, -1000,    53,   132,   132,   132,
   132,   132,   132,   132,   132,  -241,  -227,  -325,  -340,  -144,
  -145,   132,   132,    61,   132,  -292,   -15,   -36,  -116,  -244,
 -1000, -1000,  -341,   132,  -152,  -153,  -154,     5,  -165,   132,
  -168,   132,   132,   132,  1702,  -211,     3,   132,   132,   132,
   132,    52,    50,    48,     4,    44,    35,    33,    32,   132,
  -229, -1000, -1000, -1000, -1000, -1000, -1000, -1000,  -232,    28,
  -169,   132,   132,   132,   132,   132,  -175,    24,   132,     0,
 -1000, -1000, -1000, -1000,  -272, -1000, -1000, -1000,    22, -1000,
   132,  1570,  -272,  -272,  1564,  -272,  -272,  -272, -1000, -1000,
 -1000, -1000, -1000,   132,   132,   132,  1561,  -272, -1000,  -272,
 -1000, -1000, -1000,    -1, -1000,    -2, -1000,   -10,   132,  -263,
   132, -1000,   974,   132,   132,   132,   132,   132,  -272,   132,
  -272,  -272,  1558,  -191, -1000,   132,  1555,    46,   -18,  1552,
  -272,  -272,  -272, -1000, -1000, -1000,  1702, -1000, -1000, -1000,
 -1000,  1549, -1000, -1000,  1707,  1707,  1707,  1707,  1707,  1707,
  1707, -1000, -1000,  1777,   132,  -272,  -272,  -272,  -272,  -272,
   132, -1000,  -272,   132,   132,   132,   132,   132,  -306, -1000,
   132,   132,  -272,  1546,  1541,   132,  1362, -1000,  1020, -1000,
 -1000, -1000,  -272,   132,   -35,  1527,   -58, -1000,  1522,  1519,
  1506,  1503,  1500,  1485,   132,  1702,  1479,   132,  -243, -1000,
    46,  -378, -1000, -1000, -1000,   132,   817,  -191,   132, -1000,
  1476,    21, -1000, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
    14,   -70,   132,   132,   132,   132,   132,   132,    13,   132,
   132,   -78,   132,   132,   132,  1471,  1465,  1436,  -354,  -354,
 -1000, -1000, -1000,  -272,  1430,   132,   132,  1427, -1000, -1000,
 -1000,   -52,  1248, -1000, -1000, -1000, -1000,   -86,  -110,  -112,
   900,   780, -1000,  1410, -1000,   132, -1000,  1825,   132,   132,
   132,   132,   132,   132,  1407, -1000,   132,  1391,   132,    46,
    46,    46,  1419,  -130,  1134,  1388, -1000,  -191,  1385,   132,
  1742,  1693, -1000,   132,  -272,  -272,  1380,  1366,  1318,  -272,
 -1000,  -272,  -272, -1000,  -272,  1313,  1296,   132,   132,   132,
   132,  1208,  1202,   132, -1000, -1000,  -149, -1000, -1000, -1000,
   -38,    31,   -52,  -107,  -113,   780,   132,   538,  1199,   417,
 -1000, -1000, -1000,   132,   882,  1182,  1170,  1090,  1087,  1084,
   132,  1049,   132,  1056,    46,    46,  -379,   132, -1000,   132,
   132,   970, -1000, -1000, -1000, -1000, -1000,  -186, -1000,   964,
   132,   132,   132,  1118,   132,   132,   959,   936,   854,  -272,
   132,   132,  -272, -1000,    31,    31,    31,    54, -1000, -1000,
  -208,  -272, -1000,   132, -1000,   742, -1000,   132,   132,   132,
   132,   132,  -272,   132,   842, -1000,  -134,   355,  -272,   839,
   132,  1658, -1000,   132,   132,   836,  -272,   816, -1000, -1000,
  -180,   132,   132,   132,   132,   724,   718,   132,   132,   132,
   721,   597,  -374, -1000,  -374, -1000, -1000,  -272, -1000,   613,
   492,   476,   371,   246,   163,   132,   132, -1000,   132,  -272,
 -1000, -1000,   249,   132,   132,   132,  -272,  -272,  -272,  -272,
   132,   132,   135,   -17,   234, -1000,   132,  -147,  1775, -1000,
 -1000,   132, -1000,  -196, -1000,  -272,   -39,  -272,   132,  -272,
  -272,   210,  -272,  -272, -1000, -1000,   132,   109, -1000, -1000,
    96,   132, -1000,  -272,   132,    88,   132,   296,   132,    78,
    56,   132,    37, -1000,    27,   132,   132,    -3,   132,   132,
  -272,  -114,   132,   -32,   -53, -1000,  -108,   132,   132,   132,
  -167,  -122,  -128, -1000,   132,   132,  -158,  -171,   132,   132,
  -178,  -181,   132,   132,  -184,  -189,   132,   132,  -192,  -197,
   132,   132,  -213,  -219, -1000,   132,  -222,   132,  -242,   132,
  -248,   132,  -237, -1000 };
int yypgo[]={

     0,   432,     0,   433,   427,     3,    95,   180,   112,   426,
   347,   325,   359,  1862,    57,    84,  1715,    31,     1,   331,
   421,   412,   406,     2,    16,   405,   397,   395,   391,   386,
   380,   357,   355,   354,   346,   345,   340,   338,   336 };
int yyr1[]={

     0,    24,    24,    24,    24,    24,    25,    25,    25,    25,
    25,    25,    25,    25,    25,    25,    25,    25,    25,    25,
    25,    25,    25,    25,    25,    25,    25,    25,    25,     7,
     7,     7,    27,     7,    19,    19,    19,    19,    26,    26,
    26,    28,    26,    29,    26,    30,    26,    26,    18,    18,
    18,    18,    12,    12,    12,    13,    13,    13,    13,    13,
    13,    13,    13,    13,    13,    13,    13,    13,    13,    13,
    13,    13,    13,    13,    13,    13,    13,    13,    13,    13,
    31,    13,    32,    13,    33,    13,    34,    13,    35,    13,
    36,    13,    37,    13,    13,    13,    13,    13,    13,    13,
    13,    13,    13,    13,    13,    13,    13,    13,    13,     1,
     1,     1,    16,    16,    16,    16,     9,     9,    10,    10,
    11,    11,    11,    17,    17,    17,    17,    14,    14,    14,
    15,    15,    15,    15,    15,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    15,    22,    22,    23,    20,    20,
    21,    21,    21,    21,    21,     6,     6,     6,     6,     8,
    38,     8,     8,     5,     5,     5,     5,     5,     5,     3,
     3,     3,     3,     3,     3,     4,     4,     4,     4,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2 };
int yyr2[]={

     0,     0,     4,     5,     4,     5,     5,     5,     9,     5,
     5,    13,     5,     5,     5,     5,     5,     5,     5,     7,
     5,    17,    33,    13,     5,     5,     5,     5,     5,     9,
     3,     9,     1,    13,     1,     5,     5,     5,     7,     3,
     3,     1,    13,     1,    23,     1,    13,    11,     1,     5,
     5,    13,     1,     5,     5,    17,     5,    25,     5,     5,
     9,    13,     5,    13,    11,    13,     5,     5,     5,     5,
     5,     5,     9,     5,     5,     5,     5,    17,     5,     5,
     1,     7,     1,     7,     1,     7,     1,     7,     1,     7,
     1,     7,     1,     7,     5,     5,    11,     7,    13,    17,
     5,     5,     5,     5,     5,    17,     5,     5,    69,     3,
     3,     3,    11,     3,    11,     7,     3,     5,     3,     7,
    15,    11,    15,    13,    17,    17,    53,     1,     5,     5,
     5,     9,     5,     5,    13,     9,    13,     5,     5,     5,
     5,     9,     5,    13,    13,     3,     7,    11,     1,     5,
    17,     5,     5,     5,     5,     1,     5,     5,     5,    11,
     1,    15,    11,     3,     7,     7,     7,     7,     3,     3,
     5,     7,    15,     7,     7,     3,     3,     3,    11,     3,
     3,     3,     7,     3,     7,     7,     7,     7,     5 };
int yychk[]={

 -1000,   -24,   -25,    -7,   -26,    -8,   292,   298,   341,   342,
   300,   321,   322,   323,   338,   346,   315,   370,   371,   314,
   297,   301,   303,   304,   324,   352,   259,   258,   257,   264,
   -17,   -13,   377,   326,   290,   291,   289,   357,   272,   373,
   374,   305,   269,   270,   273,   283,   359,   288,   287,   286,
   285,   360,   365,   284,   355,   356,   328,   329,   349,   276,
   327,   271,   279,   293,   299,   366,   347,   306,   263,   311,
   281,   309,   351,   350,   358,   313,   312,   375,   376,    -1,
   367,   368,   369,   264,    -2,   260,   261,   361,   325,   264,
   278,    -2,    -2,    -2,    -2,    -2,    -2,    -2,   295,   295,
   296,   371,   372,   373,   267,   267,    -2,    -2,   262,    -2,
   353,   354,   265,   264,   265,   264,   265,   264,   385,   264,
   378,   379,    -2,   267,   267,   267,   265,   267,    -2,   267,
    -2,    -2,    -2,   -10,   -11,   267,    -2,   282,   259,    -2,
    -2,    -2,    -2,   264,   264,   264,   265,   264,   264,   264,
   264,    -2,   295,   296,   -31,   -32,   -33,   -34,   -35,   -36,
   -37,   295,   296,   264,   267,    -2,    -2,    -2,    -2,    -2,
   267,   264,    -2,   265,   380,   278,   381,   382,   264,    -2,
   274,   274,    -2,    -2,    -2,   274,   -12,   265,   -19,   265,
   -27,   265,    -2,   302,   -28,    -2,   -30,   265,    -2,    -2,
    -2,    -2,    -2,    -2,   274,   274,    -2,   274,    -3,    -4,
   267,   264,   260,   261,   265,   274,    -9,   -10,   274,   -16,
    -2,   311,   -16,   -16,   -16,   -16,   -16,   -16,   265,   -15,
   317,   344,   343,   316,   318,   302,   319,   330,   320,   335,
   336,   331,   364,   363,   362,    -2,    -2,    -2,    -2,    -2,
    -2,    -2,   325,    -2,    -2,   274,   274,    -2,   266,   -17,
   -13,   264,   -12,   266,   -17,   -13,    -7,   259,   258,   257,
   -19,    -6,   -38,    -2,   265,   274,   265,   -18,   274,   274,
   274,   274,   274,   274,    -2,   -11,   274,    -2,   385,    -3,
   380,   278,    -3,   383,   -12,    -2,   266,   -10,    -2,   274,
   264,   -14,   264,   265,    -2,    -2,    -2,    -2,    -2,    -2,
   264,    -2,    -2,   265,    -2,    -2,    -2,   274,   274,   274,
   274,    -2,    -2,   274,   266,   266,    -5,   -13,   -17,    -8,
   259,   267,   264,   257,   258,    -6,   274,   -24,    -2,   -24,
   266,   -17,   259,   326,    -2,    -2,    -2,    -2,    -2,    -2,
   274,    -2,   274,    -2,    -3,    -3,   268,   265,   266,   274,
   274,    -2,   265,   -15,   266,   -15,   -17,   -22,   -23,    -2,
   274,   274,   274,   -20,   274,   274,    -2,    -2,    -2,    -2,
   274,   274,    -2,   266,   380,   381,   278,    -5,   259,   264,
    -5,    -2,   266,   274,   266,    -2,   268,   274,   274,   274,
   274,   274,    -2,   274,    -2,   282,   383,    -2,    -2,    -2,
   274,   -14,   266,   274,   274,    -2,    -2,    -2,   266,   -21,
   272,   333,   332,   334,   337,    -2,    -2,   274,   274,   274,
    -2,    -2,    -5,    -5,    -5,   268,   266,    -2,   265,    -2,
    -2,    -2,    -2,    -2,    -2,   274,   265,   266,   274,    -2,
   266,   -23,    -2,   274,   274,   267,    -2,    -2,    -2,    -2,
   274,   274,    -2,    -2,    -2,   268,   274,   -29,   -18,   268,
   268,   274,   268,   268,   268,    -2,    -2,    -2,   274,    -2,
    -2,    -2,    -2,    -2,   268,   268,   274,    -2,   265,   266,
    -2,   274,   266,    -2,   274,    -2,   274,   -24,   274,    -2,
    -2,   274,    -2,   266,    -2,   274,   274,    -2,   274,   274,
    -2,    -2,   274,    -2,    -2,   268,    -2,   274,   274,   274,
    -2,    -2,    -2,   268,   274,   274,    -2,    -2,   274,   274,
    -2,    -2,   274,   274,    -2,    -2,   274,   274,    -2,    -2,
   274,   274,    -2,    -2,   266,   274,    -2,   274,    -2,   274,
    -2,   274,    -2,   266 };
int yydef[]={

     1,    -2,     2,     3,     4,     5,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    30,     0,     0,     0,
    39,    40,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    80,    82,    84,    86,    88,    90,    92,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   109,   110,   111,     6,     7,   179,   180,   181,     0,   183,
     0,     0,     9,    10,     0,    12,    13,    14,    15,    16,
    17,    18,    20,     0,     0,     0,     0,    24,    25,    26,
    27,    28,    52,     0,    34,     0,    32,     0,     0,     0,
    41,    45,     0,     0,     0,     0,     0,     0,    56,     0,
    58,    59,     0,    62,   118,     0,     0,     0,     0,     0,
    66,    67,    68,    69,    70,    71,     0,    73,    74,    75,
    76,     0,    78,    79,     0,     0,     0,     0,     0,     0,
     0,    94,    95,     0,     0,   100,   101,   102,   103,   104,
     0,   106,   107,     0,     0,     0,     0,     0,     0,   188,
     0,     0,    19,     0,     0,     0,     0,    52,     0,    34,
   155,   160,    38,     0,     0,     0,     0,    48,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,   169,
     0,   175,   176,   177,    52,     0,     0,   116,     0,    81,
   113,     0,    83,    85,    87,    89,    91,    93,   127,    97,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,   184,   185,
   186,   187,   182,     8,     0,     0,     0,     0,    29,    53,
    54,     0,     0,    31,    35,    36,    37,    30,     0,     0,
     0,     0,   155,     0,     1,     0,     1,     0,     0,     0,
     0,     0,     0,     0,    60,   119,     0,     0,     0,   170,
     0,     0,     0,     0,     0,     0,    72,   117,     0,     0,
     0,     0,   130,     0,   132,   133,     0,     0,     0,   137,
   138,   139,   140,   148,   142,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   159,   162,     0,   156,   157,   158,
   163,     0,   168,     0,     0,     0,     0,     0,     0,     0,
    47,    49,    50,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   173,   174,   171,     0,    64,     0,
     0,     0,   127,   115,    96,   128,   129,     0,   145,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,    11,
     0,     0,    23,    33,     0,     0,     0,     0,   163,   168,
     0,    98,    42,     0,    46,     0,   123,     0,     0,     0,
     0,     0,    61,     0,   121,    63,     0,     0,    65,     0,
     0,     0,   131,     0,     0,     0,   135,     0,   141,   149,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,   164,   165,   166,   167,   161,    43,    48,     0,
     0,     0,     0,     0,     0,     0,     0,   178,     0,   112,
   114,   146,     0,     0,     0,     0,   151,   152,   153,   154,
     0,     0,     0,     0,     0,    21,     0,     0,     0,   124,
   125,     0,    55,     0,   120,   122,     0,    77,     0,   134,
   136,     0,   143,   144,    99,   105,     0,     0,     1,    51,
     0,     0,   172,   147,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    44,     0,     0,     0,     0,     0,     0,
    57,     0,     0,     0,     0,   150,     0,     0,     0,     0,
     0,     0,     0,    22,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   126,     0,     0,     0,     0,     0,
     0,     0,     0,   108 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"CSG",	257,
	"COMPOSITE",	258,
	"OBJECT_TYPE",	259,
	"FLOAT",	260,
	"INTEGER",	261,
	"FILETYPE",	262,
	"OPTION",	263,
	"NAME",	264,
	"LBRACE",	265,
	"RBRACE",	266,
	"LP",	267,
	"RP",	268,
	"RADIUS",	269,
	"RADII",	270,
	"COLOUR",	271,
	"CENTER",	272,
	"VERTEX",	273,
	"COMMA",	274,
	"PCENT",	275,
	"MATERIAL",	276,
	"REFI",	277,
	"MINUS",	278,
	"AMBIENT",	279,
	"INTENSITY",	280,
	"LOCATION",	281,
	"DOLS",	282,
	"EQUATION",	283,
	"OFFFILE",	284,
	"BASE",	285,
	"TOP",	286,
	"CONST",	287,
	"COEFFS",	288,
	"SCALE",	289,
	"ROTATE",	290,
	"TRANSLATE",	291,
	"TITLE",	292,
	"REFLECTANCE",	293,
	"DOT",	294,
	"ON",	295,
	"OFF",	296,
	"LOOKAT",	297,
	"FIELDOFVIEW",	298,
	"TRANSPARENCY",	299,
	"RAYSPERPIXEL",	300,
	"BACKGROUND",	301,
	"SIZE",	302,
	"MAXHITLEVEL",	303,
	"OUTPUT",	304,
	"ORDER",	305,
	"ABSORPTION",	306,
	"VREF1",	307,
	"VREF2",	308,
	"NUMRAYS",	309,
	"OBJECT",	310,
	"TEXTURE",	311,
	"DIRECTION",	312,
	"ANGLE",	313,
	"UP",	314,
	"TWENTYFIVEBIT",	315,
	"RANGE",	316,
	"MAP",	317,
	"BLENDCOLOR",	318,
	"SCALEFACTORS",	319,
	"VORTFILE",	320,
	"HAZECOLOUR",	321,
	"FOGFACTOR",	322,
	"RFACTOR",	323,
	"FALLOFF",	324,
	"QUOTE",	325,
	"REPEAT",	326,
	"SHADOWS",	327,
	"COLOURFILE",	328,
	"VNORMALFILE",	329,
	"SCALEFACTOR",	330,
	"SOURCE",	331,
	"AMPLITUDE",	332,
	"WAVELENGTH",	333,
	"PHASE",	334,
	"TURBULENCE",	335,
	"SQUEEZE",	336,
	"DAMPING",	337,
	"SOURCERADIUS",	338,
	"NORMAL",	339,
	"COMPLEXVERTEX",	340,
	"SCREENSIZE",	341,
	"MAXTREEDEPTH",	342,
	"BLEND",	343,
	"COLOURMAP",	344,
	"MAPVALUES",	345,
	"PIXELGRID",	346,
	"RI",	347,
	"COLOURBLEND",	348,
	"NORMALFILE",	349,
	"BEAMDISTRIBUTION",	350,
	"INSIDEANGLE",	351,
	"PROJECTION",	352,
	"PERSPECTIVE",	353,
	"ORTHOGRAPHIC",	354,
	"STRIP",	355,
	"VCOLOURFILE",	356,
	"TRANSFORM",	357,
	"MINDIST",	358,
	"CLIPVOLUME",	359,
	"HEIGHTFIELD",	360,
	"FRAMENO",	361,
	"BLOCKSIZE",	362,
	"GAPCOLOUR",	363,
	"GAPSIZE",	364,
	"COLOURFIELD",	365,
	"ALPHA",	366,
	"GEOMX",	367,
	"GEOMY",	368,
	"GEOMZ",	369,
	"ANTIALIASING",	370,
	"ADAPTIVE",	371,
	"BRUTE",	372,
	"THRESHOLD",	373,
	"METABALL",	374,
	"BASIS",	375,
	"MAXSUBLEVEL",	376,
	"SUBDIVISION",	377,
	"GRID",	378,
	"KDTREE",	379,
	"PLUS",	380,
	"MULT",	381,
	"DIV",	382,
	"POWER",	383,
	"UMINUS",	384,
	"EQUALS",	385,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"input : /* empty */",
	"input : input hitem",
	"input : input object",
	"input : input statement",
	"input : input definition",
	"hitem : TITLE NAME",
	"hitem : FIELDOFVIEW expr",
	"hitem : SCREENSIZE expr COMMA expr",
	"hitem : MAXTREEDEPTH expr",
	"hitem : RAYSPERPIXEL expr",
	"hitem : HAZECOLOUR expr COMMA expr COMMA expr",
	"hitem : FOGFACTOR expr",
	"hitem : RFACTOR expr",
	"hitem : SOURCERADIUS expr",
	"hitem : PIXELGRID ON",
	"hitem : TWENTYFIVEBIT ON",
	"hitem : TWENTYFIVEBIT OFF",
	"hitem : ANTIALIASING ADAPTIVE",
	"hitem : ADAPTIVE THRESHOLD expr",
	"hitem : ANTIALIASING BRUTE",
	"hitem : UP LP expr COMMA expr COMMA expr RP",
	"hitem : LOOKAT LP expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr RP",
	"hitem : BACKGROUND expr COMMA expr COMMA expr",
	"hitem : MAXHITLEVEL expr",
	"hitem : OUTPUT FILETYPE",
	"hitem : FALLOFF expr",
	"hitem : PROJECTION PERSPECTIVE",
	"hitem : PROJECTION ORTHOGRAPHIC",
	"object : OBJECT_TYPE LBRACE body RBRACE",
	"object : OBJECT_TYPE",
	"object : COMPOSITE LBRACE compbody RBRACE",
	"object : CSG LBRACE",
	"object : CSG LBRACE csgbody csgexpr RBRACE",
	"compbody : /* empty */",
	"compbody : compbody transform",
	"compbody : compbody bodyitem",
	"compbody : compbody object",
	"statement : NAME EQUALS expr",
	"statement : transform",
	"statement : bodyitem",
	"statement : SUBDIVISION GRID",
	"statement : SUBDIVISION GRID LBRACE input RBRACE",
	"statement : SUBDIVISION GRID expr COMMA expr COMMA expr",
	"statement : SUBDIVISION GRID expr COMMA expr COMMA expr LBRACE input RBRACE",
	"statement : SUBDIVISION KDTREE",
	"statement : SUBDIVISION KDTREE LBRACE input RBRACE",
	"statement : REPEAT expr LBRACE stlist RBRACE",
	"stlist : /* empty */",
	"stlist : stlist transform",
	"stlist : stlist OBJECT_TYPE",
	"stlist : stlist REPEAT expr LBRACE stlist RBRACE",
	"body : /* empty */",
	"body : body transform",
	"body : body bodyitem",
	"bodyitem : CENTER LP expr COMMA expr COMMA expr RP",
	"bodyitem : THRESHOLD expr",
	"bodyitem : METABALL LP expr COMMA expr COMMA expr RP COMMA expr COMMA expr",
	"bodyitem : ORDER expr",
	"bodyitem : RADIUS expr",
	"bodyitem : RADII expr COMMA expr",
	"bodyitem : RADII expr COMMA expr COMMA expr",
	"bodyitem : VERTEX vbody",
	"bodyitem : EQUATION DOLS termlist EQUALS expr DOLS",
	"bodyitem : CLIPVOLUME OBJECT_TYPE LBRACE body RBRACE",
	"bodyitem : COEFFS expr COMMA expr COMMA expr",
	"bodyitem : CONST expr",
	"bodyitem : TOP expr",
	"bodyitem : BASE expr",
	"bodyitem : HEIGHTFIELD NAME",
	"bodyitem : COLOURFIELD NAME",
	"bodyitem : OFFFILE NAME",
	"bodyitem : STRIP LBRACE vlist RBRACE",
	"bodyitem : VCOLOURFILE NAME",
	"bodyitem : COLOURFILE NAME",
	"bodyitem : VNORMALFILE NAME",
	"bodyitem : NORMALFILE NAME",
	"bodyitem : MATERIAL expr COMMA expr COMMA expr COMMA expr",
	"bodyitem : SHADOWS ON",
	"bodyitem : SHADOWS OFF",
	"bodyitem : COLOUR",
	"bodyitem : COLOUR variation",
	"bodyitem : AMBIENT",
	"bodyitem : AMBIENT variation",
	"bodyitem : REFLECTANCE",
	"bodyitem : REFLECTANCE variation",
	"bodyitem : TRANSPARENCY",
	"bodyitem : TRANSPARENCY variation",
	"bodyitem : ALPHA",
	"bodyitem : ALPHA variation",
	"bodyitem : RI",
	"bodyitem : RI variation",
	"bodyitem : ABSORPTION",
	"bodyitem : ABSORPTION variation",
	"bodyitem : OPTION ON",
	"bodyitem : OPTION OFF",
	"bodyitem : TEXTURE NAME LBRACE texture_ops RBRACE",
	"bodyitem : TEXTURE NAME textitem",
	"bodyitem : NAME NAME SIZE expr COMMA expr",
	"bodyitem : LOCATION LP expr COMMA expr COMMA expr RP",
	"bodyitem : NUMRAYS expr",
	"bodyitem : INSIDEANGLE expr",
	"bodyitem : BEAMDISTRIBUTION expr",
	"bodyitem : MINDIST expr",
	"bodyitem : ANGLE expr",
	"bodyitem : DIRECTION LP expr COMMA expr COMMA expr RP",
	"bodyitem : BASIS NAME",
	"bodyitem : MAXSUBLEVEL expr",
	"bodyitem : points LBRACE expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr RBRACE",
	"points : GEOMX",
	"points : GEOMY",
	"points : GEOMZ",
	"variation : expr COMMA expr COMMA expr",
	"variation : expr",
	"variation : TEXTURE NAME LBRACE texture_ops RBRACE",
	"variation : TEXTURE NAME textitem",
	"vlist : vbody",
	"vlist : vlist vbody",
	"vbody : vitem",
	"vbody : vbody COMMA vitem",
	"vitem : LP expr COMMA expr COMMA expr RP",
	"vitem : expr COMMA expr COMMA expr",
	"vitem : expr COMMA expr COMMA expr COMMA expr",
	"transform : ROTATE LP expr COMMA expr RP",
	"transform : TRANSLATE LP expr COMMA expr COMMA expr RP",
	"transform : SCALE LP expr COMMA expr COMMA expr RP",
	"transform : TRANSFORM LBRACE expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr COMMA expr RBRACE",
	"texture_ops : /* empty */",
	"texture_ops : texture_ops textitem",
	"texture_ops : texture_ops transform",
	"textitem : MAP NAME",
	"textitem : COLOURMAP LBRACE mbody RBRACE",
	"textitem : BLEND expr",
	"textitem : RANGE expr",
	"textitem : BLENDCOLOR expr COMMA expr COMMA expr",
	"textitem : SIZE expr COMMA expr",
	"textitem : SCALEFACTORS expr COMMA expr COMMA expr",
	"textitem : SCALEFACTOR expr",
	"textitem : VORTFILE NAME",
	"textitem : TURBULENCE expr",
	"textitem : SQUEEZE expr",
	"textitem : SOURCE LBRACE wbody RBRACE",
	"textitem : GAPSIZE expr",
	"textitem : GAPCOLOUR expr COMMA expr COMMA expr",
	"textitem : BLOCKSIZE expr COMMA expr COMMA expr",
	"mbody : mitem",
	"mbody : mbody COMMA mitem",
	"mitem : expr COMMA expr COMMA expr",
	"wbody : /* empty */",
	"wbody : wbody witem",
	"witem : CENTER LP expr COMMA expr COMMA expr RP",
	"witem : WAVELENGTH expr",
	"witem : AMPLITUDE expr",
	"witem : PHASE expr",
	"witem : DAMPING expr",
	"csgbody : /* empty */",
	"csgbody : csgbody bodyitem",
	"csgbody : csgbody transform",
	"csgbody : csgbody definition",
	"definition : OBJECT_TYPE NAME LBRACE body RBRACE",
	"definition : CSG NAME LBRACE",
	"definition : CSG NAME LBRACE csgbody csgexpr RBRACE",
	"definition : COMPOSITE NAME LBRACE compbody RBRACE",
	"csgexpr : OBJECT_TYPE",
	"csgexpr : csgexpr PLUS csgexpr",
	"csgexpr : csgexpr MULT csgexpr",
	"csgexpr : csgexpr MINUS csgexpr",
	"csgexpr : LP csgexpr RP",
	"csgexpr : NAME",
	"termlist : term",
	"termlist : termlist termlist",
	"termlist : LP termlist RP",
	"termlist : LP termlist RP POWER LBRACE expr RBRACE",
	"termlist : termlist PLUS termlist",
	"termlist : termlist MINUS termlist",
	"term : NAME",
	"term : FLOAT",
	"term : INTEGER",
	"term : NAME POWER LBRACE expr RBRACE",
	"expr : FLOAT",
	"expr : INTEGER",
	"expr : FRAMENO",
	"expr : QUOTE NAME QUOTE",
	"expr : NAME",
	"expr : expr PLUS expr",
	"expr : expr MINUS expr",
	"expr : expr MULT expr",
	"expr : expr DIV expr",
	"expr : MINUS expr",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 3:
# line 139 "gram.y"
{
		object	*obj, *head;

		if ((head = objectinit(yypvt[-0].y_det->u.obj.sym, yypvt[-0].y_det->u.obj.det)) != (object *)NULL) {
			for (obj = head; obj->nxt != (object *)NULL; obj = obj->nxt)	
				;

			obj->nxt = *oblistsp;
			*oblistsp = head;
		}

		objdefined = TRUE;

		free(yypvt[-0].y_det);
	  } break;
case 5:
# line 156 "gram.y"
{
		objdefined = TRUE;

		free(yypvt[-0].y_det);
	  } break;
case 6:
# line 164 "gram.y"
{
		title = yypvt[-0].y_str;
	  } break;
case 7:
# line 168 "gram.y"
{
		float	val;

		val = eval_fexpr(yypvt[-0].y_exp);

		if (val == 0.0 || val == 360.0)
			fatal("art: idiotic angle in field of view.\n");

		focallength = focallength / tan(M_PI / 360.0 * val);
	  } break;
case 8:
# line 179 "gram.y"
{
		screenx = eval_fexpr(yypvt[-2].y_exp) / 2.0;
		screeny = eval_fexpr(yypvt[-0].y_exp) / 2.0;
	  } break;
case 9:
# line 184 "gram.y"
{
		maxtreedepth = eval_iexpr(yypvt[-0].y_exp);
	  } break;
case 10:
# line 188 "gram.y"
{
		raysperpix = eval_iexpr(yypvt[-0].y_exp);
		pixelgrid = (raysperpix > 1);
	  } break;
case 11:
# line 193 "gram.y"
{
		hazecolour.r = eval_fexpr(yypvt[-4].y_exp);
		hazecolour.g = eval_fexpr(yypvt[-2].y_exp);
		hazecolour.b = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 12:
# line 199 "gram.y"
{
		fogfactor = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 13:
# line 203 "gram.y"
{
		rfactor = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 14:
# line 207 "gram.y"
{
		sourceradius = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 15:
# line 211 "gram.y"
{
		pixelgrid = TRUE;
	  } break;
case 16:
# line 215 "gram.y"
{
		twentyfivebit(TRUE);
	  } break;
case 17:
# line 219 "gram.y"
{
		twentyfivebit(FALSE);
	  } break;
case 18:
# line 223 "gram.y"
{
		adaptive = TRUE;
	  } break;
case 19:
# line 227 "gram.y"
{
		aathreshold = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 20:
# line 231 "gram.y"
{
		adaptive = FALSE;
	  } break;
case 21:
# line 235 "gram.y"
{
		up.x = eval_fexpr(yypvt[-5].y_exp);
		up.y = eval_fexpr(yypvt[-3].y_exp);
		up.z = eval_fexpr(yypvt[-1].y_exp);
	  } break;
case 22:
# line 241 "gram.y"
{
		vector	t, u, s, eye;
		matrix	m, tmp;
		double	val, vy, vz, sinval, cosval;

		/*
		 * apply the twist
		 */
		val = eval_fexpr(yypvt[-1].y_exp) * M_PI / 180.0;
		sinval = sin(val);
		cosval = cos(val);
		mident4(m);
		m[0][0] = cosval;
		m[0][1] = -sinval;
		m[1][0] = sinval;
		m[1][1] = cosval;
		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);

		/*
		 * calculate the lookat
		 */
		eye.x = eval_fexpr(yypvt[-13].y_exp);
		eye.y = eval_fexpr(yypvt[-11].y_exp);
		eye.z = eval_fexpr(yypvt[-9].y_exp);

		t.x = eye.x - eval_fexpr(yypvt[-7].y_exp);
		t.y = eye.y - eval_fexpr(yypvt[-5].y_exp);
		t.z = eye.z - eval_fexpr(yypvt[-3].y_exp);

		u.x = up.x;
		u.y = up.y;
		u.z = up.z;

		normalise(t);

		normalise(u);

		vz = dprod(t, u);

		if (fabs(vz) >= 1.0)
			fatal("art: up vector and direction of view are the same.\n");

		vy = sqrt(1.0 - vz * vz);

		u.x = (u.x - vz * t.x) / vy;
		u.y = (u.y - vz * t.y) / vy;
		u.z = (u.z - vz * t.z) / vy;

		xprod(s, u, t);

		mident4(m);

		m[0][0] = s.x;
		m[0][1] = s.y;
		m[0][2] = s.z;

		m[1][0] = u.x;
		m[1][1] = u.y;
		m[1][2] = u.z;

		m[2][0] = t.x;
		m[2][1] = t.y;
		m[2][2] = t.z;

		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);

		mident4(m);
		m[3][0] = eye.x;
		m[3][1] = eye.y;
		m[3][2] = eye.z;
		mcpy4(tmp, trans);
		mmult4(trans, tmp, m);
					/* set up initial trans data */
		mstackp->d.omused = TRUE;
		calctransforms(mstackp);
	  } break;
case 23:
# line 320 "gram.y"
{
		backcol.r = eval_fexpr(yypvt[-4].y_exp);
		backcol.g = eval_fexpr(yypvt[-2].y_exp);
		backcol.b = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 24:
# line 326 "gram.y"
{
		maxhitlevel = eval_iexpr(yypvt[-0].y_exp);
	  } break;
case 25:
# line 330 "gram.y"
{
		filetype = yypvt[-0].y_int;
	  } break;
case 26:
# line 334 "gram.y"
{
		falloff = eval_fexpr(yypvt[-0].y_exp);
	  } break;
case 27:
# line 338 "gram.y"
{
		perspective = TRUE;
	  } break;
case 28:
# line 342 "gram.y"
{
		perspective = FALSE;
	  } break;
case 29:
# line 348 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-3].y_sym;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 30:
# line 356 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-0].y_sym;
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 31:
# line 364 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COMP_OBJ;
		yyval.y_det->u.obj.sym = (symbol *)NULL;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 32:
# line 372 "gram.y"
{
		if (ostackp->nxt == (objst *)NULL) {
			ostackp->nxt = (objst *)smalloc(sizeof(objst));
			ostackp->nxt->lst = ostackp;
			ostackp->nxt->nxt = (objst *)NULL;
		}

		ostackp = ostackp->nxt;
		ostackp->sym = (symbol *)NULL;
	  } break;
case 33:
# line 383 "gram.y"
{
		details	*d;
		symbol	*s;

		ostackp = ostackp->lst;

		d = (details *)smalloc(sizeof(details));
		d->type = yypvt[-2].y_det->type;
		d->u.csgobj.tree = yypvt[-1].y_csg;
		d->u.csgobj.det = yypvt[-2].y_det;
		d->nxt = (details *)NULL;

		s = (symbol *)smalloc(sizeof(symbol));
		s->type = CSG_OBJ;
		s->u.det = d;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = s;
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 34:
# line 408 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 35:
# line 412 "gram.y"
{
		details	*d;

		if (yypvt[-1].y_det != (details *)NULL) {
			for (d = yypvt[-1].y_det; d->nxt != (details *)NULL; d = d->nxt)
				;
			d->nxt = yypvt[-0].y_det;
			yyval.y_det = yypvt[-1].y_det;
		} else
			yyval.y_det = yypvt[-0].y_det;
	  } break;
case 36:
# line 424 "gram.y"
{
		details	*d;

		if (yypvt[-1].y_det != (details *)NULL) {
			for (d = yypvt[-1].y_det; d->nxt != (details *)NULL; d = d->nxt)
				;
			d->nxt = yypvt[-0].y_det;
			yyval.y_det = yypvt[-1].y_det;
		} else
			yyval.y_det = yypvt[-0].y_det;
	  } break;
case 37:
# line 436 "gram.y"
{
		details	*d;

		if (yypvt[-1].y_det != (details *)NULL) {
			for (d = yypvt[-1].y_det; d->nxt != (details *)NULL; d = d->nxt)
				;
			d->nxt = yypvt[-0].y_det;
			yyval.y_det = yypvt[-1].y_det;
		} else
			yyval.y_det = yypvt[-0].y_det;
	  } break;
case 38:
# line 450 "gram.y"
{
		defvar(yypvt[-2].y_str, yypvt[-0].y_exp);
	  } break;
case 39:
# line 454 "gram.y"
{
		switch (yypvt[-0].y_det->type) {
		case TRANSLATE:
			translate(yypvt[-0].y_det->u.v.x, yypvt[-0].y_det->u.v.y, yypvt[-0].y_det->u.v.z);
			break;
		case SCALE:
			scale(yypvt[-0].y_det->u.v.x, yypvt[-0].y_det->u.v.y, yypvt[-0].y_det->u.v.z);
			break;
		case ROTATE:
			rotate(yypvt[-0].y_det->u.rot.ang, yypvt[-0].y_det->u.rot.axis);
			break;
		case TRANSFORM:
			transform(*yypvt[-0].y_det->u.trans.m);
			free(yypvt[-0].y_det->u.trans.m);
			break;
		default:
			fatal("art: bad transform type in switch.\n");
		}

		free(yypvt[-0].y_det);
	  } break;
case 40:
# line 476 "gram.y"
{
		surface	*s;

			/*
			 * don't want to change someone else's
			 * material properties
			 */
		if (objdefined) {
			s = (surface *)smalloc(sizeof(surface));
			*s = *astackp->d.s;
			astackp->d.s = s;
			objdefined = FALSE;
		} else
			s = astackp->d.s;

		switch (yypvt[-0].y_det->type) {
		case COLOUR:
			s->c.r = yypvt[-0].y_det->u.c.r;
			s->c.g = yypvt[-0].y_det->u.c.g;
			s->c.b = yypvt[-0].y_det->u.c.b;
			break;
		case AMBIENT:
			s->a.r = yypvt[-0].y_det->u.c.r;
			s->a.g = yypvt[-0].y_det->u.c.g;
			s->a.b = yypvt[-0].y_det->u.c.b;
			break;
		case TEXTURE:
			yypvt[-0].y_det->u.txt->nxt = astackp->d.txtlist;
			astackp->d.txtlist = yypvt[-0].y_det->u.txt;
			break;
		case MATERIAL:
			s->ri = yypvt[-0].y_det->u.mat.ri;
			s->kd = yypvt[-0].y_det->u.mat.kd;
			s->ks = yypvt[-0].y_det->u.mat.ks;
			s->ksexp = yypvt[-0].y_det->u.mat.ksexp;
			if (s->ri == 0.0)
				s->ri = 1.0;
			break;
		case REFLECTANCE:
			s->refl = yypvt[-0].y_det->u.c;
			break;
		case TRANSPARENCY:
			s->trans = yypvt[-0].y_det->u.c;
			break;
		case ABSORPTION:
			s->falloff = yypvt[-0].y_det->u.f;
			break;
		case ON:
			astackp->d.options |= yypvt[-0].y_det->u.i;
			break;
		case OFF:
			astackp->d.options &= ~yypvt[-0].y_det->u.i;
			break;
		case SHADOWS:
			astackp->d.s->shadows = yypvt[-0].y_det->u.i;
			break;
		default:
			fatal("art: bad statement type in switch.\n");
		}

		free(yypvt[-0].y_det);
	  } break;
case 41:
# line 539 "gram.y"
{ 
		oblistsp++;
		*oblistsp = (object *)NULL;
	  } break;
case 42:
# line 544 "gram.y"
{
		object	*divobjs, *otherobjs, *nexto, *o, *obj;

		divobjs = otherobjs = (object *)NULL;

		for (o = *oblistsp; o != (object *)NULL; o = nexto) {
			nexto = o->nxt;
			o->lastray.raynumber = 0;
						/* algebraic surface or contains one */
			if (o->type == ALGEBRAIC || o->bb.max[X] == huge_dist) {
				o->nxt = otherobjs;
				otherobjs = o;
			} else if (o->type == NULL_OBJ)
				free(o);
			else {
				o->nxt = divobjs;
				divobjs = o;
			}
		}

		oblistsp--;

		obj = gridinit(divobjs);
		obj->nxt = otherobjs;

		/*
		 * add our new composite to the object stack
		 */
		if (*oblistsp != (object *)NULL) {
			for (o = *oblistsp; o->nxt != (object *)NULL; o = o->nxt)	
				;
			o->nxt = obj;
		} else {
			*oblistsp = obj;
		}

		/*
		 * add the interior objects to the general object list.
		 */
		if (subobjs != (object *)NULL) {
			for (o = subobjs; o->nxt != (object *)NULL; o = o->nxt)	
				;
			o->nxt = divobjs;
		} else {
			subobjs = divobjs;
		}
	  } break;
case 43:
# line 592 "gram.y"
{
		oblistsp++;
		*oblistsp = (object *)NULL;
	  } break;
case 44:
# line 597 "gram.y"
{
		object	*divobjs, *otherobjs, *nexto, *o, *obj;

		divobjs = otherobjs = (object *)NULL;

		for (o = *oblistsp; o != (object *)NULL; o = nexto) {
			nexto = o->nxt;
			o->lastray.raynumber = 0;
						/* algebraic surface or contains one */
			if (o->type == ALGEBRAIC || o->bb.max[X] == huge_dist) {
				o->nxt = otherobjs;
				otherobjs = o;
			} else if (o->type == NULL_OBJ)
				free(o);
			else {
				o->nxt = divobjs;
				divobjs = o;
			}
		}

		oblistsp--;

		obj = gridinit(divobjs);
		obj->nxt = otherobjs;

		/*
		 * add our new composite to the object stack
		 */
		if (*oblistsp != (object *)NULL) {
			for (o = *oblistsp; o->nxt != (object *)NULL; o = o->nxt)	
				;
			o->nxt = obj;
		} else {
			*oblistsp = obj;
		}

		/*
		 * add the interior objects to the general object list.
		 */
		if (subobjs != (object *)NULL) {
			for (o = subobjs; o->nxt != (object *)NULL; o = o->nxt)	
				;
			o->nxt = divobjs;
		} else {
			subobjs = divobjs;
		}
	  } break;
case 45:
# line 645 "gram.y"
{
		oblistsp++;
		*oblistsp = (object *)NULL;
	  } break;
case 46:
# line 650 "gram.y"
{
		object	*divobjs, *otherobjs, *nexto, *o, *obj;

		divobjs = otherobjs = (object *)NULL;

		for (o = *oblistsp; o != (object *)NULL; o = nexto) {
			nexto = o->nxt;
			o->lastray.raynumber = 0;
						/* algebraic surface or contains one */
			if (o->type == ALGEBRAIC || o->bb.max[X] == huge_dist) {
				o->nxt = otherobjs;
				otherobjs = o;
			} else if (o->type == NULL_OBJ)
				free(o);
			else {
				o->nxt = divobjs;
				divobjs = o;
			}
		}

		oblistsp--;

		obj = treeinit(divobjs);
		obj->nxt = otherobjs;

		/*
		 * add our new composite to the object stack
		 */
		if (*oblistsp != (object *)NULL) {
			for (o = *oblistsp; o->nxt != (object *)NULL; o = o->nxt)	
				;
			o->nxt = obj;
		} else {
			*oblistsp = obj;
		}

		/*
		 * add the interior objects to the general object list.
		 */
		if (subobjs != (object *)NULL) {
			for (o = subobjs; o->nxt != (object *)NULL; o = o->nxt)	
				;
			o->nxt = divobjs;
		} else {
			subobjs = divobjs;
		}
	  } break;
case 47:
# line 698 "gram.y"
{
		dorepeat(yypvt[-3].y_exp, yypvt[-1].y_det);
	  } break;
case 48:
# line 704 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 49:
# line 708 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 50:
# line 713 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-0].y_sym;
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = yypvt[-1].y_det;
	  } break;
case 51:
# line 722 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = REPEAT;
		yyval.y_det->u.rpt.expr = yypvt[-3].y_exp;
		yyval.y_det->u.rpt.stmt = yypvt[-1].y_det;
		yyval.y_det->nxt = yypvt[-5].y_det;
	  } break;
case 52:
# line 734 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 53:
# line 738 "gram.y"
{
		details	*d;

		if (yypvt[-1].y_det != (details *)NULL) {
			for (d = yypvt[-1].y_det; d->nxt != (details *)NULL; d = d->nxt)
				;
			d->nxt = yypvt[-0].y_det;
			yyval.y_det = yypvt[-1].y_det;
		} else
			yyval.y_det = yypvt[-0].y_det;
	  } break;
case 54:
# line 750 "gram.y"
{
		details	*d;

		if (yypvt[-1].y_det != (details *)NULL) {
			for (d = yypvt[-1].y_det; d->nxt != (details *)NULL; d = d->nxt)
				;
			d->nxt = yypvt[-0].y_det;
			yyval.y_det = yypvt[-1].y_det;
		} else
			yyval.y_det = yypvt[-0].y_det;
	  } break;
case 55:
# line 764 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CENTER;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 56:
# line 773 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = THRESHOLD;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 57:
# line 780 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = METABALL;
		yyval.y_det->u.mb = (mball *)smalloc(sizeof(mball));
		yyval.y_det->u.mb->v.x = eval_fexpr(yypvt[-9].y_exp);
		yyval.y_det->u.mb->v.y = eval_fexpr(yypvt[-7].y_exp);
		yyval.y_det->u.mb->v.z = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.mb->r = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.mb->s = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 58:
# line 792 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ORDER;
		yyval.y_det->u.i = eval_iexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 59:
# line 799 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADIUS;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 60:
# line 806 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADII;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 61:
# line 814 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RADII;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 62:
# line 823 "gram.y"
{
		if (yypvt[-0].y_det->nxt == (details *)NULL) {
			yypvt[-0].y_det->type = VERTEX;
			yyval.y_det = yypvt[-0].y_det;
		} else {
			yyval.y_det = (details *)smalloc(sizeof(details));
			yyval.y_det->type = COMPLEXVERTEX;
			yyval.y_det->u.det = yypvt[-0].y_det;
			yyval.y_det->nxt = (details *)NULL;
		}
	  } break;
case 63:
# line 835 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = EQUATION;
		yyval.y_det->u.t = (term *)smalloc(sizeof(term));
		yyval.y_det->u.t->coef = -eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->u.t->xp = 0;
		yyval.y_det->u.t->yp = 0;
		yyval.y_det->u.t->zp = 0;
		yyval.y_det->u.t->nxt = yypvt[-3].y_trm;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 64:
# line 847 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = yypvt[-3].y_sym;
		yyval.y_det->u.obj.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 65:
# line 855 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COEFFS;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 66:
# line 864 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CONST;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 67:
# line 871 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TOP;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 68:
# line 878 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BASE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 69:
# line 885 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = HEIGHTFIELD;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 70:
# line 892 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOURFIELD;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 71:
# line 899 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OFFFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 72:
# line 906 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = STRIP;
		yyval.y_det->u.det = yypvt[-1].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 73:
# line 913 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VCOLOURFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 74:
# line 920 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOURFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 75:
# line 927 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VNORMALFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 76:
# line 934 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = NORMALFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 77:
# line 941 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MATERIAL;
		yyval.y_det->u.mat.ri = eval_fexpr(yypvt[-6].y_exp);
		yyval.y_det->u.mat.kd = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.mat.ks = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.mat.ksexp = eval_iexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 78:
# line 951 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SHADOWS;
		yyval.y_det->u.i = TRUE;
		yyval.y_det->nxt = (details *)NULL;

		astackp->d.shadows = TRUE;
	  } break;
case 79:
# line 960 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SHADOWS;
		yyval.y_det->u.i = FALSE;
		yyval.y_det->nxt = (details *)NULL;

		astackp->d.shadows = FALSE;
	  } break;
case 80:
# line 968 "gram.y"
{ fieldtype = COLOUR; } break;
case 81:
# line 969 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 82:
# line 972 "gram.y"
{ fieldtype = AMBIENT; } break;
case 83:
# line 973 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 84:
# line 976 "gram.y"
{ fieldtype = REFLECTANCE; } break;
case 85:
# line 977 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 86:
# line 980 "gram.y"
{ fieldtype = TRANSPARENCY; } break;
case 87:
# line 981 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 88:
# line 984 "gram.y"
{ fieldtype = ALPHA; } break;
case 89:
# line 985 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 90:
# line 988 "gram.y"
{ fieldtype = RI; } break;
case 91:
# line 989 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 92:
# line 992 "gram.y"
{ fieldtype = ABSORPTION; } break;
case 93:
# line 993 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 94:
# line 997 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ON;
		yyval.y_det->u.i = yypvt[-1].y_int;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 95:
# line 1004 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = OFF;
		yyval.y_det->u.i = yypvt[-1].y_int;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 96:
# line 1011 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-3].y_str, yypvt[-1].y_det, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 97:
# line 1018 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-1].y_str, yypvt[-0].y_det, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 98:
# line 1025 "gram.y"
{
		details	*d1, *d2;

		d1 = (details *)smalloc(sizeof(details));
		d1->type = VORTFILE;
		d1->u.s = yypvt[-4].y_str;

		d2 = (details *)smalloc(sizeof(details));
		d2->type = SIZE;
		d2->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		d2->u.v.y = eval_fexpr(yypvt[-0].y_exp);

		d1->nxt = d2;
		d2->nxt = (details *)NULL;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit("tile", d1, COLOUR);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 99:
# line 1046 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = CENTER;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 100:
# line 1055 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = NUMRAYS;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 101:
# line 1062 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = INSIDEANGLE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 102:
# line 1069 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BEAMDISTRIBUTION;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 103:
# line 1076 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MINDIST;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 104:
# line 1083 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ANGLE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 105:
# line 1090 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = DIRECTION;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 106:
# line 1099 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BASIS;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 107:
# line 1106 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MAXSUBLEVEL;
		yyval.y_det->u.i = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 108:
# line 1116 "gram.y"
{
		matrix	m;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = yypvt[-33].y_int;

		mident4(m);

		m[0][0] = eval_fexpr(yypvt[-31].y_exp);
		m[0][1] = eval_fexpr(yypvt[-29].y_exp);
		m[0][2] = eval_fexpr(yypvt[-27].y_exp);
		m[0][3] = eval_fexpr(yypvt[-25].y_exp);

		m[1][0] = eval_fexpr(yypvt[-23].y_exp);
		m[1][1] = eval_fexpr(yypvt[-21].y_exp);
		m[1][2] = eval_fexpr(yypvt[-19].y_exp);
		m[1][3] = eval_fexpr(yypvt[-17].y_exp);

		m[2][0] = eval_fexpr(yypvt[-15].y_exp);
		m[2][1] = eval_fexpr(yypvt[-13].y_exp);
		m[2][2] = eval_fexpr(yypvt[-11].y_exp);
		m[2][3] = eval_fexpr(yypvt[-9].y_exp);

		m[3][0] = eval_fexpr(yypvt[-7].y_exp);
		m[3][1] = eval_fexpr(yypvt[-5].y_exp);
		m[3][2] = eval_fexpr(yypvt[-3].y_exp);
		m[3][3] = eval_fexpr(yypvt[-1].y_exp);

		yyval.y_det->u.trans.m = (matrix *)smalloc(sizeof(matrix));

		mcpy4(*yyval.y_det->u.trans.m, m);

		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 109:
# line 1153 "gram.y"
{
		yyval.y_int = GEOMX;
	  } break;
case 110:
# line 1157 "gram.y"
{
		yyval.y_int = GEOMY;
	  } break;
case 111:
# line 1161 "gram.y"
{
		yyval.y_int = GEOMZ;
	  } break;
case 112:
# line 1167 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = fieldtype;
		yyval.y_det->u.c.r = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.c.g = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 113:
# line 1176 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = fieldtype;
		yyval.y_det->u.c.r = yyval.y_det->u.c.g = yyval.y_det->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 114:
# line 1183 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-3].y_str, yypvt[-1].y_det, fieldtype);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 115:
# line 1190 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TEXTURE;
		yyval.y_det->u.txt = textureinit(yypvt[-1].y_str, yypvt[-0].y_det, fieldtype);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 116:
# line 1199 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		if (yypvt[-0].y_det->nxt == (details *)NULL)
			yyval.y_det->type = VERTEX;
		else
			yyval.y_det->type = COMPLEXVERTEX;
		yyval.y_det->u.det = yypvt[-0].y_det;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 117:
# line 1209 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		if (yypvt[-0].y_det->nxt == (details *)NULL)
			yyval.y_det->type = VERTEX;
		else
			yyval.y_det->type = COMPLEXVERTEX;
		yyval.y_det->u.det = yypvt[-0].y_det;
		yyval.y_det->nxt = yypvt[-1].y_det;
	  } break;
case 118:
# line 1221 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 119:
# line 1225 "gram.y"
{
		if (yypvt[-0].y_det->nxt != (details *)NULL)
			yypvt[-0].y_det->nxt->nxt = yypvt[-2].y_det;
		else
			yypvt[-0].y_det->nxt = yypvt[-2].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 120:
# line 1235 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VERTEX;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 121:
# line 1244 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 122:
# line 1253 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = COLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-6].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->nxt = (details *)smalloc(sizeof(details));
		yyval.y_det->nxt->type = TRANSPARENCY;
		yyval.y_det->nxt->u.c.r = yyval.y_det->nxt->u.c.g = yyval.y_det->nxt->u.c.b = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt->nxt = (details *)NULL;
	  } break;
case 123:
# line 1267 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = ROTATE;
		yyval.y_det->u.rot.ang = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.rot.axis = eval_iexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 124:
# line 1275 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TRANSLATE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 125:
# line 1284 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 126:
# line 1296 "gram.y"
{
		matrix	m;

		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TRANSFORM;

		mident4(m);

		m[0][0] = eval_fexpr(yypvt[-23].y_exp);
		m[0][1] = eval_fexpr(yypvt[-21].y_exp);
		m[0][2] = eval_fexpr(yypvt[-19].y_exp);

		m[1][0] = eval_fexpr(yypvt[-17].y_exp);
		m[1][1] = eval_fexpr(yypvt[-15].y_exp);
		m[1][2] = eval_fexpr(yypvt[-13].y_exp);

		m[2][0] = eval_fexpr(yypvt[-11].y_exp);
		m[2][1] = eval_fexpr(yypvt[-9].y_exp);
		m[2][2] = eval_fexpr(yypvt[-7].y_exp);

		m[3][0] = eval_fexpr(yypvt[-5].y_exp);
		m[3][1] = eval_fexpr(yypvt[-3].y_exp);
		m[3][2] = eval_fexpr(yypvt[-1].y_exp);

		yyval.y_det->u.trans.m = (matrix *)smalloc(sizeof(matrix));

		minv4(*yyval.y_det->u.trans.m, m);

		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 127:
# line 1329 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 128:
# line 1333 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 129:
# line 1338 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-1].y_det;
		yyval.y_det = yypvt[-0].y_det;
	  } break;
case 130:
# line 1345 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = MAP;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 131:
# line 1352 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = MAPVALUES;
                yyval.y_det->u.cm = mapinit(yypvt[-1].y_det);
                yyval.y_det->nxt = (details *)NULL;
          } break;
case 132:
# line 1359 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLEND;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 133:
# line 1366 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = RANGE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 134:
# line 1373 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLENDCOLOR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 135:
# line 1382 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SIZE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 136:
# line 1390 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALEFACTORS;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 137:
# line 1399 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SCALEFACTOR;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 138:
# line 1406 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = VORTFILE;
		yyval.y_det->u.s = yypvt[-0].y_str;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 139:
# line 1413 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = TURBULENCE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 140:
# line 1420 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = SQUEEZE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 141:
# line 1427 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = SOURCE;
                yyval.y_det->u.w = waveinit(yypvt[-1].y_det);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 142:
# line 1434 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = GAPSIZE;
		yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 143:
# line 1441 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = GAPCOLOUR;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 144:
# line 1450 "gram.y"
{
		yyval.y_det = (details *)smalloc(sizeof(details));
		yyval.y_det->type = BLOCKSIZE;
		yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
		yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
		yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 145:
# line 1461 "gram.y"
{
		yyval.y_det = yypvt[-0].y_det;
	} break;
case 146:
# line 1465 "gram.y"
{
		yypvt[-0].y_det->nxt = yypvt[-2].y_det;
		yyval.y_det = yypvt[-0].y_det;
	} break;
case 147:
# line 1472 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = MAPVALUES;
                yyval.y_det->u.v.x = eval_fexpr(yypvt[-4].y_exp);
                yyval.y_det->u.v.y = eval_fexpr(yypvt[-2].y_exp);
                yyval.y_det->u.v.z = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 148:
# line 1482 "gram.y"
{
                yyval.y_det = (details *)NULL;
          } break;
case 149:
# line 1486 "gram.y"
{
                yypvt[-0].y_det->nxt = yypvt[-1].y_det;
                yyval.y_det = yypvt[-0].y_det;
          } break;
case 150:
# line 1493 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = CENTER;
                yyval.y_det->u.v.x = eval_fexpr(yypvt[-5].y_exp);
                yyval.y_det->u.v.y = eval_fexpr(yypvt[-3].y_exp);
                yyval.y_det->u.v.z = eval_fexpr(yypvt[-1].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 151:
# line 1502 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = WAVELENGTH;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 152:
# line 1509 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = AMPLITUDE;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 153:
# line 1516 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = PHASE;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 154:
# line 1523 "gram.y"
{
                yyval.y_det = (details *)smalloc(sizeof(details));
                yyval.y_det->type = DAMPING;
                yyval.y_det->u.f = eval_fexpr(yypvt[-0].y_exp);
                yyval.y_det->nxt = (details *)NULL;
	  } break;
case 155:
# line 1533 "gram.y"
{
		yyval.y_det = (details *)NULL;
	  } break;
case 156:
# line 1537 "gram.y"
{
		details	*d;

		if (yypvt[-1].y_det != (details *)NULL) {
			for (d = yypvt[-1].y_det; d->nxt != (details *)NULL; d = d->nxt)
				;
			d->nxt = yypvt[-0].y_det;
			yyval.y_det = yypvt[-1].y_det;
		} else
			yyval.y_det = yypvt[-0].y_det;
	  } break;
case 157:
# line 1549 "gram.y"
{
		details	*d;

		if (yypvt[-1].y_det != (details *)NULL) {
			for (d = yypvt[-1].y_det; d->nxt != (details *)NULL; d = d->nxt)
				;
			d->nxt = yypvt[-0].y_det;
			yyval.y_det = yypvt[-1].y_det;
		} else
			yyval.y_det = yypvt[-0].y_det;
	  } break;
case 158:
# line 1561 "gram.y"
{
		details	*d;

		if (yypvt[-1].y_det != (details *)NULL) {
			for (d = yypvt[-1].y_det; d->nxt != (details *)NULL; d = d->nxt)
				;
			d->nxt = yypvt[-0].y_det;
			yyval.y_det = yypvt[-1].y_det;
		} else
			yyval.y_det = yypvt[-0].y_det;
	  } break;
case 159:
# line 1575 "gram.y"
{
		defobj(yypvt[-3].y_str, yypvt[-4].y_sym->type, yypvt[-1].y_det);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = lookup(yypvt[-3].y_str);
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 160:
# line 1586 "gram.y"
{
		if (ostackp->nxt == (objst *)NULL) {
			ostackp->nxt = (objst *)smalloc(sizeof(objst));
			ostackp->nxt->lst = ostackp;
			ostackp->nxt->nxt = (objst *)NULL;
		}

		ostackp = ostackp->nxt;
		ostackp->sym = (symbol *)NULL;
	  } break;
case 161:
# line 1597 "gram.y"
{
		details	*d;

		ostackp = ostackp->lst;

		d = (details *)smalloc(sizeof(details));

		d->type = yypvt[-1].y_csg->type;
		d->u.csgobj.tree = yypvt[-1].y_csg;
		d->u.csgobj.det = yypvt[-2].y_det;
		d->nxt = (details *)NULL;

		defobj(yypvt[-5].y_str, CSG_OBJ, d);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = lookup(yypvt[-5].y_str);
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 162:
# line 1619 "gram.y"
{
		defobj(yypvt[-3].y_str, COMP_OBJ, yypvt[-1].y_det);

		yyval.y_det = (details *)smalloc(sizeof(details));

		yyval.y_det->type = OBJECT;
		yyval.y_det->u.obj.sym = lookup(yypvt[-3].y_str);
		yyval.y_det->u.obj.det = (details *)NULL;
		yyval.y_det->nxt = (details *)NULL;
	  } break;
case 163:
# line 1633 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = OBJECT;
		yyval.y_csg->u.sym = yypvt[-0].y_sym;
	  } break;
case 164:
# line 1639 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_ADD;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 165:
# line 1646 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_INT;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 166:
# line 1653 "gram.y"
{
		yyval.y_csg = (csgnode *)smalloc(sizeof(csgnode));
		yyval.y_csg->type = CSG_SUB;
		yyval.y_csg->u.branch.left = yypvt[-2].y_csg;
		yyval.y_csg->u.branch.right = yypvt[-0].y_csg;
	  } break;
case 167:
# line 1660 "gram.y"
{
		yyval.y_csg = yypvt[-1].y_csg;
	  } break;
case 168:
# line 1664 "gram.y"
{
		char	buf[BUFSIZ];

		sprintf(buf, "art: object %s not defined.\n", yypvt[-0].y_str);
		fatal(buf);
	  } break;
case 169:
# line 1673 "gram.y"
{
		yyval.y_trm = yypvt[-0].y_trm;
	  } break;
case 170:
# line 1677 "gram.y"
{
		term	*t, *p, *np, *prod;

		prod = (term *)NULL;
		for (p = yypvt[-1].y_trm; p != (term *)NULL; p = p->nxt) {
			for (np = yypvt[-0].y_trm; np != (term *)NULL; np = np->nxt) {
				t = (term *)smalloc(sizeof(term));
				*t = *np;
				t->coef *= p->coef;
				t->xp += p->xp;
				t->yp += p->yp;
				t->zp += p->zp;
				t->nxt = prod;
				prod = t;
			}
		}

		for (t = yypvt[-1].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		for (t = yypvt[-0].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		yyval.y_trm = prod;
	  } break;
case 171:
# line 1707 "gram.y"
{
		yyval.y_trm = yypvt[-1].y_trm;
	  } break;
case 172:
# line 1711 "gram.y"
{
		term	*t, *p, *np, *prod, *nprod;
		int	i, power;

		prod = yypvt[-5].y_trm;
		power = eval_iexpr(yypvt[-1].y_exp);

		for (i = 1; i != power; i++) {		
			nprod = (term *)NULL;
			for (p = yypvt[-5].y_trm; p != (term *)NULL; p = p->nxt) {
				for (np = prod; np != (term *)NULL; np = np->nxt) {
					t = (term *)smalloc(sizeof(term));
					*t = *np;
					t->coef *= p->coef;
					t->xp += p->xp;
					t->yp += p->yp;
					t->zp += p->zp;
					t->nxt = nprod;
					nprod = t;
				}
			}
			if (prod != yypvt[-5].y_trm)
				for (t = prod; t != (term *)NULL; t = np) {
					np = t->nxt;
					free(t);
				}
			prod = nprod;
		}

		for (t = yypvt[-5].y_trm; t != (term *)NULL; t = np) {
			np = t->nxt;
			free(t);
		}

		yyval.y_trm = prod;
	  } break;
case 173:
# line 1748 "gram.y"
{
		term	*p;

		for (p = yypvt[-0].y_trm; p->nxt != (term *)NULL; p = p->nxt)
			;
		yyval.y_trm = yypvt[-0].y_trm;
		p->nxt = yypvt[-2].y_trm;
	  } break;
case 174:
# line 1757 "gram.y"
{
		term	*p, *lp;

		for (p = yypvt[-0].y_trm; p != (term *)NULL; p = p->nxt) {
			p->coef *= -1.0;
			lp = p;
		}

		yyval.y_trm = yypvt[-0].y_trm;
		lp->nxt = yypvt[-2].y_trm;
	  } break;
case 175:
# line 1771 "gram.y"
{
		char	*p;

		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = 1;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;

		for (p = yypvt[-0].y_str; *p != 0; p++)
			switch (*p) {
			case 'x':
				yyval.y_trm->xp += 1;
				break;
			case 'y':
				yyval.y_trm->yp += 1;
				break;
			case 'z':
				yyval.y_trm->zp += 1;
				break;
			default:
				fatal("art: illegal name in equation.\n");
			}
	  } break;
case 176:
# line 1797 "gram.y"
{
		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = yypvt[-0].y_flt;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;
	  } break;
case 177:
# line 1806 "gram.y"
{
		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = yypvt[-0].y_int;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;
	  } break;
case 178:
# line 1815 "gram.y"
{
		char	*p;
		int	power;

		yyval.y_trm = (term *)smalloc(sizeof(term));
		yyval.y_trm->coef = 1;
		yyval.y_trm->xp = 0;
		yyval.y_trm->yp = 0;
		yyval.y_trm->zp = 0;
		yyval.y_trm->nxt = (term *)NULL;

		power = eval_iexpr(yypvt[-1].y_exp);

		for (p = yypvt[-4].y_str; *p != 0; p++)
			switch (*p) {
			case 'x':
				yyval.y_trm->xp += 1;
				break;
			case 'y':
				yyval.y_trm->yp += 1;
				break;
			case 'z':
				yyval.y_trm->zp += 1;
				break;
			default:
				fatal("art: illegal name in equation.\n");
			}

		p--;

		switch (*p) {
		case 'x':
			yyval.y_trm->xp += power - 1;
			break;
		case 'y':
			yyval.y_trm->yp += power - 1;
			break;
		case 'z':
			yyval.y_trm->zp += power - 1;
			break;
		default:
			fatal("art: illegal name in equation.\n");
		}
	  } break;
case 179:
# line 1862 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_FLOAT;
		yyval.y_exp->u.f = yypvt[-0].y_flt;
	  } break;
case 180:
# line 1868 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = yypvt[-0].y_int;
	  } break;
case 181:
# line 1874 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = frameno;
	  } break;
case 182:
# line 1880 "gram.y"
{
		yyval.y_exp = (expression *)smalloc(sizeof(expression));
		yyval.y_exp->type = EXP_INT;
		yyval.y_exp->u.i = *yypvt[-1].y_str;
		free(yypvt[-1].y_str);
	  } break;
case 183:
# line 1887 "gram.y"
{
		yyval.y_exp = get_varexpr(yypvt[-0].y_str);
	  } break;
case 184:
# line 1891 "gram.y"
{
		yyval.y_exp = get_expr(EXP_ADD, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 185:
# line 1895 "gram.y"
{
		yyval.y_exp = get_expr(EXP_SUB, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 186:
# line 1899 "gram.y"
{
		yyval.y_exp = get_expr(EXP_MUL, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 187:
# line 1903 "gram.y"
{
		yyval.y_exp = get_expr(EXP_DIV, yypvt[-2].y_exp, yypvt[-0].y_exp);
	  } break;
case 188:
# line 1907 "gram.y"
{
		yyval.y_exp = get_expr(EXP_UMINUS, yypvt[-0].y_exp, (expression *)NULL);
	  } break;
	}
	goto yystack;		/* reset registers in driver code */
}
